/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  
  
  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 
  
      http://www.apache.org/licenses/LICENSE-2.0 
  
  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/

#include "glite/ce/monitor-client-api-c/CEConsumerP.h"
//#include "glite/ce/monitor-client-api-c/Topic.h"

#include <iostream>
#include <unistd.h>
#include <sys/time.h>

#include "glite/ce/monitor-client-api-c/CEMON_CONSUMER.nsmap"

using namespace std;

Namespace namespaces[] = {};

int main(int argc, char *argv[])
{
  int port;
  CEConsumerP *consumer;

  if(argc<2) exit(1);

  port = atoi(argv[1]);

  consumer = new CEConsumerP(port);
  
  while(!consumer->bind())
    {
      cout << "error message=" << consumer->getErrorMessage() << endl;
      cout << "error code   =" << consumer->getErrorCode() << endl;
      cout << "Retrying in 5 seconds..." <<endl;
      sleep(5);
    }
    {
      cout << "Socket connection successful on port " << consumer->getLocalPort()
	   << " master socket "<< consumer->getLocalSocket()<<endl;
      time_t lastTime = time(NULL);
      time_t delta=0, before=0, after=0, D = 0;
      bool ret;
      int i=0;
      while(true)
	{
	  before = time(NULL);
	  if(!consumer->accept())
	    {
	      cout << "error message=" << consumer->getErrorMessage() << endl;
	      cout << "error code   =" << consumer->getErrorCode() << endl;
	      break;
	    }
	  after = time(NULL); D=after-before;
	  //if( D ) lastTime += D;
	  //cout << "after-before "<<D<<" - lastTime="<<lastTime<<endl;
	  if(D) lastTime += D;
	  //cout << i << " after-before " << D << " - lastTime="<<lastTime<<endl;
	
	  ret = consumer->serve();

	if(!ret) {
	  cout << "ErrorCode=[" << consumer->getErrorCode() << "]"<<endl;
	  cout << "ErrorMess=[" << consumer->getErrorMessage() << "]"<<endl;
	}
	//else {}
	if( i == 5000 )
	{
	  delta = (time(NULL) - lastTime);
	  lastTime = time(NULL);
	  i=0;
	  printf("5000 events processed in %d seconds\n", (int)delta);
	}
	i++;
      }
    }
    delete(consumer);
}
