/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  
  
  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 
  
      http://www.apache.org/licenses/LICENSE-2.0 
  
  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/

#include "glite/ce/monitor-client-api-c/monitor_consumer_CEMON_CONSUMERStub.h"
#include "glite/ce/monitor-client-api-c/CEMON_CLIENT.nsmap"
#include "glite/ce/monitor-client-api-c/Topic.h"
#include<iostream>
#include<string>
#include<ctime>

using namespace std;

int main( int argc, char* argv[] )
{
  struct soap* SOAP;
  SOAP = soap_new();
  monitortypes__Notification Notification;
  monitorws__NotifyResponse _param_1;
  
  if(!SOAP)
    cerr << "Error creating the SOAP runtime"<<endl;
    
  Notification.ExpirationTime = time(NULL)+120;
  Notification.Topic = new  monitortypes__Topic();
  Notification.Topic->Name = "ProfileTest";
  Notification.ConsumerURL = new string("consumer url");
  monitortypes__Event evt;
  //gettimeofday(&tv, NULL);
  evt.Timestamp = time(NULL);
  evt.Message.push_back("Messaggio");
  if(argv[2])
    evt.Producer = argv[2];
  else
    evt.Producer = "Unknown Producer";
  Notification.Event.push_back( &evt );
  soap_set_namespaces(SOAP, CEMON_CLIENT_namespaces);
  
  int numOfEvts;
  if(argv[3])
    numOfEvts = atoi(argv[3]);
  else
    numOfEvts = 1000;
    
  int j = 0;
  time_t delta;
  time_t lastTime = 0;
  time_t before = time(NULL);
  lastTime = time(NULL);
  while(evt.ID++<numOfEvts) {
    Notification.Event.clear();
    Notification.Event.push_back( &evt );
    soap_call_monitorws__Notify(SOAP, argv[1], NULL, &Notification, _param_1);
    if(j==5000) {
      delta = time(NULL) - lastTime;
      lastTime = time(NULL);
      j=0;
      printf("5000 events sent in %d second\n", (int)delta);
    }
    j++;
  }
  time_t after = time(NULL);
  
  time_t Delta = after-before;
  printf("Total time= %d - Num of events= %d\n", (int)Delta, numOfEvts);
  
  delete(SOAP);
}
