/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  
  
  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 
  
      http://www.apache.org/licenses/LICENSE-2.0 
  
  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/

#include "glite/ce/monitor-client-api-c/monitor_client_CEMON_CLIENTStub.h"
#include "CEMON_CLIENT.nsmap"

SOAP_NMAC struct Namespace namespaces[] = {};

int main(int argc, char* argv[]) {

  

  struct soap S;
  soap_init(&S);
  
  int tcpport = 9000;
  if(argv[1])
    tcpport = atoi(argv[1]);

  soap_set_namespaces(&S, CEMON_CLIENT_namespaces);

  int m = soap_bind(&S, NULL, tcpport, 100);
  if (m < 0)
    soap_print_fault(&S, stderr); 
  else
    {
      fprintf(stderr, "Socket connection successful: master socket = %d\n", m);
      for (int i = 1; ; i++)
	{
	  int s = soap_accept(&S);
	  if (s < 0)
	    {
	      soap_print_fault(&S, stderr);
	      break;
	    }
	  fprintf(stderr, 
		  "%d: accepted connection from IP=%d.%d.%d.%d socket=%d\n", 
		  i,
		  (S.ip >> 24)&0xFF,
		  (S.ip >> 16)&0xFF,
		  (S.ip >> 8)&0xFF,
		  S.ip&0xFF, 
		  s);
	  
	  if (CEMON_CLIENT_serve(&S) != SOAP_OK) // process RPC request
            soap_print_fault(&S, stderr); // print error
	  
	  fprintf(stderr, "request served\n");
	  
	  soap_destroy(&S); // clean up class instances
	  soap_end(&S); // clean up everything and close socket
	}
    }
  soap_done(&S); // close master socket and detach environment 
}

SOAP_FMAC5 int SOAP_FMAC6 monitorws__GetEvent(struct soap* soap, monitortypes__Topic *T, struct monitorws__GetEventResponse &resp) 
{
  return soap_sender_fault(soap, "server FAULT!", "<fault xsi:type=\"ns2:DelegationException\"><message>User not authorized:&#xA;unable to check credential permission  (/opt/glite/etc/glite_wms_wmproxy.gacl)&#xA;(credential entry not found)&#xA;credential type: voms&#xA;rawvalue : /EGEE/Role=NULL/Capability=NULL&#xA;</message></fault>");
}

SOAP_FMAC5 int SOAP_FMAC6 monitorws__GetTopicEvent(struct soap* soap, monitortypes__Topic *T, struct monitorws__GetTopicEventResponse &resp)
{
  monitortypes__EventArray *evA = new monitortypes__EventArray();
  //evA.soap = soap;
  monitortypes__Event *evt = new monitortypes__Event();
  monitortypes__Event *evt2 = new monitortypes__Event();
  monitortypes__Event *evt3 = new monitortypes__Event();
  //evt->soap = soap;
  evt->ID=1;
  evt->Timestamp = time(0);
  evt->Message.push_back("Messaggio1=FANCULO");
  evt->Message.push_back("Messaggio2=FOTTITI");
  evt->Producer="mini-server";
  
    evt2->ID=2;
  evt2->Timestamp = time(0);
  evt2->Message.push_back("Messaggio1=FANCULO2");
  evt2->Message.push_back("Messaggio2=FOTTITI2");
  evt2->Producer="mini-server";
  
    evt3->ID=3;
  evt3->Timestamp = time(0);
  evt3->Message.push_back("Messaggio1=FANCULO3");
  evt3->Message.push_back("Messaggio2=FOTTITI3");
  evt3->Producer="mini-server";
  
  
  evA->event.push_back( evt );
  evA->event.push_back( evt2 );
  evA->event.push_back( evt3 );
  
  resp.eventArray = evA;
  return SOAP_OK;
}

SOAP_FMAC5 int SOAP_FMAC6  monitorws__GetSubscriptionRef(soap*, monitorws__GetSubscriptionRefResponse&)
{
  return SOAP_OK;
}


SOAP_FMAC5 int SOAP_FMAC6  monitorws__GetSubscription(soap*, monitortypes__SubscriptionRefList*, monitorws__GetSubscriptionResponse&)
{
  return SOAP_OK;
}

SOAP_FMAC5 int SOAP_FMAC6   monitorws__Update(soap*, monitortypes__Subscription*, monitorws__UpdateResponse&)
{
  return SOAP_OK;
}

//<ns1:TopicNotSupportedFault xmlns:ns1=\"http://glite.org/ce/monitorapij/faults\"><MethodName>getEvent</MethodName><Timestamp>2005-10-21T08:48:46.226Z</Timestamp><ErrorCode>7</ErrorCode><Description>Topic &quot;CE_MONITOR&quot; not supported</Description><FaultCause>topicHolder.checkSupportedTopic( topic ) == false</FaultCause></ns1:TopicNotSupportedFault><ns2:exceptionName xmlns:ns2=\"http://xml.apache.org/axis/\">org.glite.ce.monitorapij.faults.GenericFault</ns2:exceptionName><ns3:hostname xmlns:ns3=\"http://xml.apache.org/axis/\">grid005.pd.infn.it</ns3:hostname>

//<ns1:GenericFault xmlns:ns1=\"http://glite.org/ce/faults\"><MethodName>getEvent</MethodName><Timestamp>2005-10-21T08:48:46.226Z</Timestamp><ErrorCode>7</ErrorCode><Description>Topic &quot;CE_MONITOR&quot; not supported</Description><FaultCause>topicHolder.checkSupportedTopic( topic ) == false</FaultCause></ns1:GenericFault><ns2:exceptionName xmlns:ns2=\"http://xml.apache.org/axis/\">org.glite.ce.monitorapij.faults.GenericFault</ns2:exceptionName><ns3:hostname xmlns:ns3=\"http://xml.apache.org/axis/\">grid005.pd.infn.it</ns3:hostname>
SOAP_FMAC5 int SOAP_FMAC6 monitorws__Ping(struct soap*, struct monitorws__PingResponse &_param_1)
{
  return SOAP_OK;
}

SOAP_FMAC5 int SOAP_FMAC6 monitorws__GetInfo(struct soap*, struct monitorws__GetInfoResponse &_param_2)
{
  return SOAP_OK;
}

SOAP_FMAC5 int SOAP_FMAC6 monitorws__Subscribe(struct soap*, monitortypes__Subscription *ns2__Subscription, struct monitorws__SubscribeResponse &_param_3)
{
  return SOAP_OK;
}

SOAP_FMAC5 int SOAP_FMAC6 monitorws__Unsubscribe(struct soap*, monitortypes__SubscriptionRef *ns2__SubscriptionRef, struct monitorws__UnsubscribeResponse &_param_4)
{
  return SOAP_OK;
}

SOAP_FMAC5 int SOAP_FMAC6 monitorws__PauseSubscription(struct soap*, monitortypes__SubscriptionRef *ns2__SubscriptionRef, struct monitorws__PauseSubscriptionResponse &_param_5)
{
  return SOAP_OK;
}

SOAP_FMAC5 int SOAP_FMAC6 monitorws__ResumeSubscription(struct soap*, monitortypes__SubscriptionRef *ns2__SubscriptionRef, struct monitorws__ResumeSubscriptionResponse &_param_6)
{
  return SOAP_OK;
}

SOAP_FMAC5 int SOAP_FMAC6 monitorws__GetTopics(struct soap*, struct monitorws__GetTopicsResponse &_param_7) 
{
  monitortypes__TopicArray *TopicArray = new monitortypes__TopicArray();
  monitortypes__Topic *t1, *t2, *t3;
  
  t1 = new monitortypes__Topic();
  t1->Name = "Topic 1";
  t1->visibility = 0;
  
  t2 = new monitortypes__Topic();
  t2->Name = "Topic 2";
  t2->visibility = 0;
  
  t3 = new monitortypes__Topic();  
  t3->Name = "Topic 3";
  t3->visibility = 0;
  
  TopicArray->Topic.push_back( t1 );
  TopicArray->Topic.push_back( t2 );
  TopicArray->Topic.push_back( t3 );
  
  _param_7.TopicArray = TopicArray;
  
  return SOAP_OK;
}


SOAP_FMAC5 int SOAP_FMAC6 monitorws__Notify(struct soap*, monitortypes__Notification *ns2__Notification, struct monitorws__NotifyResponse &_param_9){
  return SOAP_OK;
}
